/* Messages Macrocoder demo - library file - Copyright (c) 2016 by DAFOCUS */
#ifndef __MESSAGES_LIB_H
#define __MESSAGES_LIB_H

#define DECODE_ERROR 0xFFFFFFFF

/*------------------------------------------------------------------------------
This function copies given number of bits starting from given sourceOffsetInBits
from "source" buffer to "destination" buffer.  Bits are aligned on destination
buffer starting from bit "destinationOffsetInBits".

Bit-positions are expressed as follows:
- bit 0 is the highest (most significant) bit of octet 0;
- bit 7 is the lowest (less significant) bit of octet 0;
- bit 8 is the highest (most significant) bit of octet 1;
...and so on.

Both Lenght and Offsets are expressed in bits.
------------------------------------------------------------------------------*/
void copyBits(void* destination, unsigned destinationOffsetInBits, const void* source, unsigned sourceOffsetInBits, unsigned lengthInBits);

/*------------------------------------------------------------------------------
This function copies 'lengthInBits' less significant bits of 'source' integer to
'destination' ad offset 'Offset'.
------------------------------------------------------------------------------*/
void unsignedToBits(void* destination, unsigned destinationOffsetInBits, unsigned long source, unsigned lengthInBits);

/*------------------------------------------------------------------------------
This function copies 'lengthInBits' less significant bits of 'source' char buffer
from offset 'Offset'. Read integer is returned.
------------------------------------------------------------------------------*/
unsigned long bitsToUnsigned(const void* source, unsigned sourceOffsetInBits, unsigned lengthInBits);

#endif
